Global ("IS", {
		[INNATE_STAT_STRENGTH] = "Strength",
		[INNATE_STAT_MIGHT] = "Might",
		[INNATE_STAT_DEXTERITY] = "Dexterity",
		[INNATE_STAT_AGILITY] = "Agility",
		[INNATE_STAT_STAMINA] = "Stamina",
		[INNATE_STAT_PRECISION] = "Precision",
		[INNATE_STAT_HARDINESS] = "Hardiness",
		[INNATE_STAT_INTELLECT] = "Intellect",
		[INNATE_STAT_INTUITION] = "Intuition",
		[INNATE_STAT_SPIRIT] = "Spirit",
		[INNATE_STAT_WILL] = "Will",
		[INNATE_STAT_RESOLVE] = "Resolve",
		[INNATE_STAT_WISDOM] = "Wisdom",
		[INNATE_STAT_LETHALITY] = "Lethality"
})
Global ("RD", {
	ver = {common.GetAddonName(),4, "03/11/2011","Nikon","Unit Detector"},
	ids = {},	--ID`s tables // 1-friends 2-enemies 3-mobs 4-devices
	obj = {{},{},{},{}},	--Objects`s tables // 1-friends 2-enemies 3-crown 4-searched
	maxTbl = {10,10,1,1},
	searched = common.GetEmptyWString(),		--search WString
	timer = Sets.rTime,
	upTime = Sets.rTime,
	unitsChanged = true,
	block = true,
	blockscan = true
})

function RD:SetBlock (onoff)
self.block = onoff
--self.timer = onoff and Sets.rTime or self.timer
self.timer = onoff and self.upTime or self.timer
return onoff
end

function RD:DetectCh (params)
self.unitsChanged = true
if not self.blockscan and params then
	if params.spawned then self:ObjSearch(params.spawned)
	elseif params.unitId and params.unitId == self.obj[4].id then self:ObjRescan ()
	end
end
end

function RD:setcolor (num,id,quality)
if object.IsDead(id) then return 1 end
if quality then return quality == UNIT_QUALITY_BOSS and 7 or 6 end
return (unit.GetPvPFlagInfo(id).isOn and 1 or 0) + num * 2
end

function RD:addid (id)
if unit.IsPlayer(id) then
	if unit.IsFriend(id) then table.insert(self.ids[1],id)
	else table.insert(self.ids[2],id)
	end
elseif not unit.IsPet(id) then table.insert(self.ids[3],id)
end
end

function RD:GetidList ()
for i=1,3 do self.ids[i] = {} end
local tbl = avatar.GetUnitList()
if not tbl then return end
for v,t in tbl do self:addid(t) end
end

function RD:ObjRescan ()
if self.blockscan then return end
self.unitsChanged = true
self.obj[4].id = nil
self:ObjSearch (avatar.GetUnitList())
if not self.obj[4].id then self:ObjSearch (avatar.GetDeviceList()) end
end

function RD:ObjSearch (tbl)
if self.obj[4].id or self.blockscan then return end
local nam
for v,t in tbl do
	nam = object.GetName(t)
	if common.IsSubstringEx(nam, self.searched) and (not object.IsUnit(t) and true or not object.IsDead(t)) then
		self.obj[4].id = t
		self.obj[4].name = nam
		--self.block = false
		self.unitsChanged = true
		--object.Highlight( t, "AMBIENT", {r=0.5,g=0,b=1,a=0.1}, {r=1,g=0,b=0,a=1.0}, 3)
		--if object.IsExist(t) then
			object.Highlight( t, "AMBIENT", {r=1,g=0,b=0,a=1.0}, {r=1,g=1,b=1,a=1.0}, 5)
		--end
		--break
	end
end
end

function RD:GetObjects ()
--local tt = {mission.GetLocalTimeHMS(),0}
local tbl, n = {}
for i=1,2 do self.obj[i] = {} end
self:GetidList()
for i=1,2 do
	for v,t in self.ids[i] do
		tbl = {}
		tbl.id = t
		tbl.level = unit.GetLevel(t)
		tbl.className = unit.GetClass(t)
		tbl.className, tbl.clasLocal = tbl.className.className, tbl.className.name
		tbl.colorText = unit.GetPrimaryTarget(t)==avatar.GetId() and 1 or 0
		tbl.color = self:setcolor (i,t)
		table.insert(self.obj[i],tbl)
	end
end
n = table.getn(self.obj[1]) + table.getn(self.obj[2])
self.upTime = Sets.rTime * (n < 11 and 1 or (n < 31 and 2 or (n < 51 and 3 or 4)))
--self.upTime = Sets.rTime * (n < 11 and 2 or (n < 31 and 4 or (n < 51 and 6 or 8)))
--common.LogInfo(common.GetAddonName(),"n = ",tostring(n)," upTime ",tostring(self.upTime))

--Sort
for i=1, 2 do
	if self.obj[i][2] then
		if Sets.onSort then
			table.sort(self.obj[i], function(a, b) return (1e5*a.level+1e10*a.colorText-a.id) > (1e5*b.level+1e10*b.colorText-b.id)end)
		else
			table.sort(self.obj[i], function(a, b) return (a.id) < (b.id)end)
		end
	end
end

--elite
self.obj[3].id = nil
for v,t in self.ids[3] do
	n = unit.GetQuality(t)
	--if ((n == UNIT_QUALITY_BOSS) or (n == UNIT_QUALITY_FLAVOR_ELITE)) and not object.IsDead(t) then
	if n == UNIT_QUALITY_FLAVOR_ELITE and not object.IsDead(t) then
	--if n == UNIT_QUALITY_CRITTER and not object.IsDead(t) then
		self.obj[3].id = t
		self.obj[3].level = unit.GetLevel(t)
		self.obj[3].className = "MOB"
		self.obj[3].colorText = 0
		self.obj[3].color = self:setcolor (3,t,n)
		--self.block = false
		self.unitsChanged = true
		break
	end
end
--searched
if self.obj[4].id then
	self.obj[4].id = object.IsExist(self.obj[4].id) and self.obj[4].id or nil
	if not self.obj[4].id then self:ObjRescan () end
end
end

function RD:Update ()
if self.block then return end
--if self.timer < Sets.rTime then
if self.timer < self.upTime then
	self.timer = self.timer+1
else
	self.timer = 1
	if self.unitsChanged then
		self:GetObjects ()
		self.unitsChanged = false
		return true
	end
end
end

function RD:count (numtbl)
--return table.getn(self.ids[numtbl==1 and 1 or 2])
return table.getn(self.obj[numtbl==1 and 1 or 2])
end

function RD:Init ()
self.block = false
self.unitsChanged = true
self.upTime = Sets.rTime
self.blockscan = string.len(userMods.FromWString(self.searched)) < 1
self.obj[4].id = not self.blockscan and self.obj[4].id or nil
self:ObjRescan ()
end